/**
 ******************************************************************************
 * Copyright (c), Takenori Imoto
 *  software http://www.kaede-software.com/
 * All rights reserved.
 ******************************************************************************
 * \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏
 * ꍇɌAĔЕzюgp܂B
 *
 * E\[XR[hĔЕzꍇAL̒쌠\A{ꗗAщLƐ
 *   ܂߂邱ƁB
 * EoCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
 *   쌠\A{ꗗAщLƐӏ܂߂邱ƁB
 * Eʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔
 *   iɁAgD̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB
 *
 * {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v
 * ĂAَ킸AƓIȎgp\Aѓ̖ړIɑ΂K
 * ɊւÖق̕ۏ؂܂߁A܂Ɍ肳ȂAȂۏ؂܂
 * B쌠҂Rgr[^[AR̂킸AQ̌
 * 킸AӔC̍_ł邩iӔCł邩iߎ̑́js@
 * sׂł邩킸Aɂ̂悤ȑQ\m炳ĂƂ
 * ĂA{\tgEFA̎gpɂĔi֕i܂͑pT[rX̒BA
 * gp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ肳
 * jڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQ
 * āAؐӔC𕉂Ȃ̂Ƃ܂B
 ******************************************************************************
 * {\tgEFÁAgg2 ( http://kikyou.info/tvp/ ) ̃\[XR[hJava
 * ɏ̂ꕔgpĂ܂B
 * gg2 Copyright (C) W.Dee <dee@kikyou.info> and contributors
 ******************************************************************************
 */
package jp.kirikiri.tvp2.visual;

import jp.kirikiri.tjs2.TJSException;

public interface DivisibleTransHandler extends BaseTransHandler {

	/**
	 * called before one processing time unit.
	 * expected return values are:
	 * S_TRUE: continue processing
	 * S_FALSE: break processing
	 * @param tick
	 * @return
	 */
	public int startProcess( /*in*/long tick );

	/**
	 * called after one processing time unit.
	 * expected return values are:
	 * S_TRUE: continue processing
	 * S_FALSE: break processing
	 */
	public int endProcess();

	/**
	 * called during StartProcess and EndProcess per an update rectangle.
	 * the handler processes given rectangle and put result image to
	 * "Dest"( in tTVPDivisibleData ).
	 * given "Dest" is a internal image buffer, but callee can change
	 * the "Dest" pointer to Src1 or Src2. Also DestLeft and DestTop can
	 * be changed to point destination image part.
	 * @throws TJSException
	 */
	public int process( /*in,out*/DivisibleData data ) throws TJSException;

	/**
	 * will be called after StartProcess/EndProcess returns S_FALSE.
	 * this function does not called in some occasions.
	 * fill "dest" to make a final image.
	 * dest can be set to either src1 or src2.
	 * @throws TJSException
	 */
	public int makeFinalImage( /*in,out*/ScanLineProvider dest, /*in*/ScanLineProvider src1, /*in*/ScanLineProvider src2 ) throws TJSException;
}
