/**
 ******************************************************************************
 * Copyright (c), Takenori Imoto
 *  software http://www.kaede-software.com/
 * All rights reserved.
 ******************************************************************************
 * \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏
 * ꍇɌAĔЕzюgp܂B
 *
 * E\[XR[hĔЕzꍇAL̒쌠\A{ꗗAщLƐ
 *   ܂߂邱ƁB
 * EoCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
 *   쌠\A{ꗗAщLƐӏ܂߂邱ƁB
 * Eʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔
 *   iɁAgD̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB
 *
 * {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v
 * ĂAَ킸AƓIȎgp\Aѓ̖ړIɑ΂K
 * ɊւÖق̕ۏ؂܂߁A܂Ɍ肳ȂAȂۏ؂܂
 * B쌠҂Rgr[^[AR̂킸AQ̌
 * 킸AӔC̍_ł邩iӔCł邩iߎ̑́js@
 * sׂł邩킸Aɂ̂悤ȑQ\m炳ĂƂ
 * ĂA{\tgEFA̎gpɂĔi֕i܂͑pT[rX̒BA
 * gp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ肳
 * jڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQ
 * āAؐӔC𕉂Ȃ̂Ƃ܂B
 ******************************************************************************
 * {\tgEFÁAgg2 ( http://kikyou.info/tvp/ ) ̃\[XR[hJava
 * ɏ̂ꕔgpĂ܂B
 * gg2 Copyright (C) W.Dee <dee@kikyou.info> and contributors
 ******************************************************************************
 */
package jp.kirikiri.tvp2.visual;

import jp.kirikiri.tvp2env.Font;

public class FontInfomation {
	private String mFaceName;
	private int mHeight;
	private int mFlags;
	private int mAngle;

	public FontInfomation() {}
	public FontInfomation( final String face, int height, int flags, int angle ) {
		mFaceName = face;
		mHeight = height;
		mFlags = flags;
		mAngle = angle;
	}
	public FontInfomation( Font f ) {
		mFaceName = f.getFaceName();
		mHeight = f.getHeight();
		mAngle = f.getAngle();
		mFlags = 0;
		mFlags |= f.getBold() ? Font.TF_BOLD : 0;
		mFlags |= f.getItalic() ? Font.TF_ITALIC : 0;
		mFlags |= f.getStrikeout() ? Font.TF_STRIKEOUT : 0;
		mFlags |= f.getUnderline() ? Font.TF_UNDERLINE : 0;
	}
	public FontInfomation(FontInfomation font) {
		mFaceName = font.mFaceName;
		mHeight = font.mHeight;
		mFlags = font.mFlags;
		mAngle = font.mAngle;
	}
	public void setFont( Font f ) {
		mFaceName = f.getFaceName();
		mHeight = f.getHeight();
		mAngle = f.getAngle();
		mFlags = 0;
		mFlags |= f.getBold() ? Font.TF_BOLD : 0;
		mFlags |= f.getItalic() ? Font.TF_ITALIC : 0;
		mFlags |= f.getStrikeout() ? Font.TF_STRIKEOUT : 0;
		mFlags |= f.getUnderline() ? Font.TF_UNDERLINE : 0;
	}
	public boolean equals(Object o){
		if( o instanceof FontInfomation ) {
			FontInfomation f = (FontInfomation)o;
			if( mFaceName == null ) {
				if( mFaceName == f.mFaceName && mHeight == f.mHeight && mFlags == f.mFlags && mAngle == f.mAngle ) {
					return true;
				} else {
					return false;
				}
			} else if( mFaceName.equals( f.mFaceName) && mHeight == f.mHeight && mFlags == f.mFlags && mAngle == f.mAngle ) {
				return true;
			} else {
				return false;
			}
		} else {
			return false ;
		}
	}
	public int hashCode() {
		int hash = 0;
		if( mFaceName != null ) {
			hash = mFaceName.hashCode();
		}
		hash ^= mFlags;
		hash ^= mAngle;
		hash ^= mHeight;
		return hash;
	}
}
