/**
 ******************************************************************************
 * Copyright (c), Takenori Imoto
 *  software http://www.kaede-software.com/
 * All rights reserved.
 ******************************************************************************
 * \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏
 * ꍇɌAĔЕzюgp܂B
 *
 * E\[XR[hĔЕzꍇAL̒쌠\A{ꗗAщLƐ
 *   ܂߂邱ƁB
 * EoCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
 *   쌠\A{ꗗAщLƐӏ܂߂邱ƁB
 * Eʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔
 *   iɁAgD̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB
 *
 * {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v
 * ĂAَ킸AƓIȎgp\Aѓ̖ړIɑ΂K
 * ɊւÖق̕ۏ؂܂߁A܂Ɍ肳ȂAȂۏ؂܂
 * B쌠҂Rgr[^[AR̂킸AQ̌
 * 킸AӔC̍_ł邩iӔCł邩iߎ̑́js@
 * sׂł邩킸Aɂ̂悤ȑQ\m炳ĂƂ
 * ĂA{\tgEFA̎gpɂĔi֕i܂͑pT[rX̒BA
 * gp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ肳
 * jڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQ
 * āAؐӔC𕉂Ȃ̂Ƃ܂B
 ******************************************************************************
 * {\tgEFÁAgg2 ( http://kikyou.info/tvp/ ) ̃\[XR[hJava
 * ɏ̂ꕔgpĂ܂B
 * gg2 Copyright (C) W.Dee <dee@kikyou.info> and contributors
 ******************************************************************************
 */
package jp.kirikiri.tvp2.visual;

import jp.kirikiri.tjs2.TJSException;
import jp.kirikiri.tvp2.msg.Message;
import jp.kirikiri.tvp2env.NativeImageBuffer;

public class ScanLineProviderForBaseBitmap implements ScanLineProvider {
	private boolean mOwn;
	BaseBitmap mBitmap;

	public ScanLineProviderForBaseBitmap( BaseBitmap bmp ) {
		this(bmp,false);
	}
	public ScanLineProviderForBaseBitmap( BaseBitmap bmp, boolean own ) {
		mOwn = own;
		mBitmap = bmp;
	}

	/**
	 * attach bitmap
	 * @param bmp
	 */
	public void attach( BaseBitmap bmp ) {
		mBitmap = bmp;
	}
	@Override
	public int getWidth() {
		return mBitmap.getWidth();
	}

	@Override
	public int getHeight() {
		return mBitmap.getHeight();
	}

	@Override
	public int getPixelFormat() {
		return mBitmap.getBPP();
	}

	@Override
	public int getPitchBytes() {
		return mBitmap.getPitchBytes();
	}

	@Override
	public NativeImageBuffer getScanLine() {
		return mBitmap.getBitmap();
	}

	@Override
	public NativeImageBuffer getScanLineForWrite() {
		mBitmap.independ();
		NativeImageBuffer ret = mBitmap.getBitmap();
		ret.toMutable();
		return ret;
	}
	@Override
	public void copyFrom(ScanLineProvider src) throws TJSException {
		if( src instanceof ScanLineProviderForBaseBitmap ) {
			ScanLineProviderForBaseBitmap s = (ScanLineProviderForBaseBitmap)src;
			mBitmap = s.mBitmap;
			mOwn = s.mOwn;
		} else {
			Message.throwExceptionMessage(Message.InternalError);
		}
	}
}
